/*********************************************************************
  All ADuC7023 library code provided by ADI, including this file, is provided
 as is without warranty of any kind, either expressed or implied.
 You assume any and all risk from the use of this code.  It is the
 responsibility of the person integrating this code into an application
 to ensure that the resulting application performs as required and is safe.

 Author        : ADI - Apps            www.analog.com/ADuC7023

 Date          : February 2009

 File          : ADC.c

 Hardware      : Applicable to ADuC7023 rev A later silicon
                 
 Description   : Simple test to check ADC functionality
 				Connect output of DAC0 to ADC0 channel
		
*********************************************************************/
#include <aduc7023.h>
unsigned int uiPLLTST = 0;
volatile unsigned int ucTest = 0;

void ADCpoweron(int);
int main(void) 
{
	unsigned short ADCDATA[256];
	int i;
	
/*	POWKEY1 = 0x01;					// Configure CPU Clock for 41.78MHz, CD=0
 	POWCON = 0x00;
 	POWKEY2 = 0xF4;	
*/
	GP0DAT = 0x80000000;			// Set P0.7 as LED output
 		// Configure Timer 1
    T1LD            = 0x700;      	// Enable Timer 1
    T1CON           = 0x4C0;         // Periodic, HCLK, div/1
    IRQEN 		   |=0x8;			// Enable timer1 IRQ source 

/*	 		// Configure Timer 0
    T0LD            = 0x700;      	// Enable Timer 0
    T0CON           = 0xC0;         // Periodic, HCLK, div/1
    IRQEN 		    |=0x4;			// Enable timer0 IRQ source 
*/
//	DAC0CON = 0x13;					// Set DAC0 output to 0-AVDD range and turn DAC0 on
//	DAC0DAT = 0x04000000;			// start from midscale
	REFCON = 0x01;					// internal 2.5V reference. 2.5V on Vref pin
	ADCpoweron(20000);				// power on ADC
	ADCCP = 0x00;	  				// select ADC channel 0
	ADCCN = 0x01;	  				// select ADC channel 1

	ADCCON = 0xEEC;					// ADC Config: fADC/8, acq. time = 8 clocks, Differential mode, Continuous conversion mode
//	ADCCON = 0xEE9;					// Conversions via Timer 1 overflows
//	ADCCON = 0xEEA;					// Conversions via Timer 0 overflows 
	while (1) 
	{
		GP0DAT ^= 0x00800000;		// Complement P0.7
									// start continuous conversion
		for (i=0; i <256; i++) 
		{
		while (!ADCSTA){}			// wait for end of conversion
		ADCDATA[i] = (ADCDAT >> 16);
		}
		GP0DAT ^= 0x00800000;		// Complement P0.7
	}				
}
void IRQ_Handler(void) __irq
{
	unsigned long IRQSTATUS = 0;
	
	IRQSTATUS = IRQSTA;	   			// Read off IRQSTA register
	if ((IRQSTATUS & 0x8) == 0x8)	// Timer1 interrupt source
	{
		T1CLRI = 0xFF;				// Clear current timer Interrupt
	}
	if ((IRQSTATUS & 0x4) == 0x4)	// Timer0 interrupt source
	{
		T0CLRI = 0xFF;				// Clear current timer Interrupt
	}
}
void ADCpoweron(int time)
{
	ADCCON = 0x20;	 					// power-on the ADC
	while (time >=0)	  				// wait for ADC to be fully powered on
    time--;
}
